---
title: 'get ArrayBuffer[@@species]'
slug: Web/JavaScript/Reference/Global_Objects/ArrayBuffer/@@species
tags:
  - ArrayBuffer
  - JavaScript
  - Property
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <strong><code>ArrayBuffer[@@species]</code></strong> accessor property returns the <code>ArrayBuffer</code> constructor.</p>

<h2 id="Description">Description</h2>

<p>The species accessor property returns the default constructor for <code>ArrayBuffer</code> objects. Subclass constructors may over-ride it to change the constructor assignment.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Species_in_ordinary_objects">Species in ordinary objects</h3>

<p>The species property returns the default constructor function, which is the <code>ArrayBuffer</code> constructor for <code>ArrayBuffer</code> objects:</p>

<pre class="brush: js notranslate">ArrayBuffer[Symbol.species]; // function ArrayBuffer()</pre>

<h3 id="Species_in_derived_objects">Species in derived objects</h3>

<p>In a derived collection object (e.g. your custom array buffer <code>MyArrayBuffer</code>), the <code>MyArrayBuffer</code> species is the <code>MyArrayBuffer</code> constructor. However, you might want to overwrite this, in order to return parent <code>ArrayBuffer</code> objects in your derived class methods:</p>

<pre class="brush: js notranslate">class MyArrayBuffer extends ArrayBuffer {
  // Overwrite MyArrayBuffer species to the parent ArrayBuffer constructor
  static get [Symbol.species]() { return ArrayBuffer; }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-get-arraybuffer-@@species', 'get ArrayBuffer [ @@species ]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.ArrayBuffer.@@species")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("ArrayBuffer")}}</li>
 <li>{{jsxref("Symbol.species")}}</li>
</ul>
